<?php

// Load functions, no code executed here:
require("string_functions.php");
require("misc_functions.php");
require("print_functions.php");
require("config.php");

require("login.php"); // if not logged in, ask login and password

// Create mailboxes if they don't exist allready
@imap_createmailbox( $conn, imap_utf7_encode("{".$server."}".$f_drafts) );
@imap_subscribe ( $conn, imap_utf7_encode("{".$server."}".$f_drafts) );
@imap_createmailbox( $conn, imap_utf7_encode("{".$server."}".$f_saved) );
@imap_subscribe ( $conn, imap_utf7_encode("{".$server."}".$f_saved) );

// *** Script inputs ***
$uid = preg_replace("/[^\d]/","",$_REQUEST['uid']);	// tonumber
$action = str_word(strtolower($_REQUEST['action'])); // anum lcase
$folder=preg_replace("/[^\w-\/]/","", $_REQUEST['folder']); //called mailbox in rfc
if (""=="$folder") { $folder="INBOX"; }
$part = preg_replace("/[^\d]/","",$_REQUEST['part']);
$page = preg_replace("/[^\d]/","",$_REQUEST['page']); // tonumber
if ("" == $page) $page=1;
$query=$_REQUEST['q']; // todo security: Clean up, dangerous
$note=$_REQUEST['note'];
$noteminor=$_REQUEST['noteminor'];

$send_to = address_encode($_REQUEST['to']);
$send_cc = address_encode($_REQUEST['cc']);
$send_from=address_encode($_REQUEST['from']);
$send_subject=header_encode( $_REQUEST['subject'] );
$send_body=utf8_decode($_REQUEST['body']);

switch ($action) {
#	case "save": // this is not in the right place...
#		$nums = array(imap_msgno($conn, $uid));	
#		if ( imap_mail_move ($conn, "1", "Trash") ) {
#			$note="Saved to $f_saved.";		
#		} else {
#			$note="Save failed.";
#			$noteminor="Cannot move: $folder ".implode(",",$nums)."uid=$uid  to $f_saved. ".imap_last_error()."\n";
#		}
#	break;
// 				"From: $send_from\r\nContent-type: text/plain; charset=utf-8"

	case "savesend":
		// todo: allways save a copy
		// $send_body = imap_utf8($send_body);
		// todo: From address should be what user entered
		if ( 1==imap_mail($send_to, $send_subject, $send_body, 
				"From: $send_from\r\nContent-type: text/plain; charset=iso-8859-1") ) {
				// "Content-Transfer-Encoding: 7bit" is the default (rfc2045)
			$note="Message sent. ";
			$noteminor="Sent to ".$send_to." with subject ".$send_subject.". ";
			header( "Location: index.php?note=".urlencode($note)."&noteminor=".urlencode($noteminor) );
		} else {	
			$note="Sending message failed:".imap_last_error()."\n"; // todo: don't lose msgs
			$noteminor="Message was To: $send_to From: $myname Subject: $send_subject $send_body";
		}
	break;	
	case "download":
		view_part($conn, imap_msgno($conn, $uid), $part);
		die; 	// todo: put header in this switch, if for footer, don't die
	case "logout":
		session_destroy();
		header( "Location: index.php" );
		die();
		// todo: force exit here
	break;
	case "":
		if (""<>$query) { 
			$action="search"; 
		} else {
			$action="summary";
		}
	break;
}

require("header.php"); //	sourcelink("toolbar.php"); sourcelink("header.php");
require("toolbar.php"); // sourcelink("mailboxes.php");

echo "<!--Subscribed folders -->\n";
print_folders($conn,$server,$folder);

?>
<!--Notes, that explain what we did-->
<h1><?php echo $note?></h1>
<p class="small"><?php echo $noteminor?></p>

<?php

echo "<!--Find message numbers-->";
switch ($action) {
	// Get msgs numbers (search or basic sort)
	case "search":
		$nums = @imap_sort($conn, SORTARRIVAL, 1, FOOBAR, imap_and_query($query) );	
		$noteminor = 
			"Search for '".imap_and_query($query)
			."' (case insensitive, AND, anywhere) returned "
			.sizeOf($nums)." messages from ".$folder.".";
		// SE_UID needed if we combine boxes
		break;
	case "message":
	case "reply":
	case "source":
		$nums = array(imap_msgno($conn, $uid));		
		break;
	case "compose":
		$nums = array(0);
		break;
	default:
		$action="summary"; // if we fell here because no break in switch
		//$nums = @imap_sort($conn, SORTARRIVAL, 1, FOOBAR, "SINCE 7-Mar-2003");
		$nums = @imap_sort($conn, SORTARRIVAL, 1);
		$noteminor = "Summary of ".sizeOf($nums). " messages in $folder. ";
		for ($i=1;$i*$msgs_per_page<sizeOf($nums); $i++) {
			if ($i==$page) {
				$noteminor = $noteminor."$i ";
			} else {
				$noteminor = $noteminor."<a href=\"?page=$i\">$i</a> ";
			}
		}
		#$noteminor = $noteminor."Summary of ".sizeOf($nums). " messages in $folder.";
		break;
}

require("content.php");
?><p class="info"><?php echo $noteminor?></p><?php
imap_close($conn, CL_EXPUNGE); // when and where to close?
require("footer.php");
?>

