<?php
// These functions print html to screen
// All html should be XHTML Basic 1.0 with compatibility (such as <br />)

function print_compose($from, $to, $cc, $subject, $body) {
        // print form to compose a message to be sent
        // used for "new message", reply, forward. (and bounce, if we allow bouncing)
        // enctype is rfc2045 content-type
        // todo: check that body is wrapped

	function print_inputfield($friendlyname, $len, $value) {
		$id=strtolower(str_word($friendlyname)); // id is lower_case alphanumeric and -_
		?>
		<label class="right" for="<?php echo($id)?>">
			<?php echo($friendlyname)?>
		</label>
		<input class="left" 
			id="<?php echo($id)?>"
			name="<?php echo($id)?>" 
			type="text" 
			size="<?php echo($len)?>" 
			value="<?php echo($value)?>" />
		<br />
		<?php
	}	
	
	function print_compose_buttons() {
		?>
		<p>
		<input type="submit" name="send" value="Send Message" /> 
		<!--&nbsp; <input type="submit" name="save" value="Save" />-->
		</p>
		<?php
	}

// <form method="post" action="index.php" enctype="text/plain; charset=iso-8859-1">
	?>
<form method="post" action="index.php" enctype="text/plain; charset=iso-8859-1">
	
	<?php print_compose_buttons(); ?>
	<p> <?php 
		print_inputfield("From", 50, $from); ?> 
	</p>
	<p>
	<?php
		print_inputfield("To", 50, $to);
		print_inputfield("Cc", 80, $cc);
	?></p>
	
	<p>
	<?php print_inputfield("Subject", 80, $subject); ?>
	</p>
	<p>
	<textarea id="body" name="body" rows="30" cols="73"><?php echo $body ?></textarea>
      	<input type="hidden" name="action" value="savesend" />
	</p>
	
	<?php print_compose_buttons(); ?>
</form>

<?php
}

function print_folders($conn,$server,$current_folder)   // print subscribed mailboxes with links to mailbox summary
{
	echo "<p class=\"sans\">\n";
	$folders = imap_listsubscribed($conn,"{".$server."}","mail*"); // 1-dimensional array $folders has all boxes but INBOX        if (!is_array($folders)) { echo "imap_list failed: ".imap_last_error()." <br>\n"; }
	array_unshift($folders, "{".$server."}"."INBOX"); // $boxes[0]="{127.0.0.1:143/imap/notls}INBOX", $folders[1]=..Sent $        // echo implode(" <br>", array_values($folders) ); // print raw list of boxes
	foreach ($folders as $folder) { // folder raw folder, like "{127.0.0.1:143/imap/notls}INBOX"
		$fname=preg_replace("/.*(}|\/)/", "", $folder); // like "Sent"
		$fpathname=preg_replace("/.*(})/", "", $folder);        // like "mail/Sent"
		if ("INBOX"<>"$fname") { echo " - \n"; }
		if ("$current_folder"=="$fpathname") { echo "<em>"; }
		echo "<a href='index.php?action=summary&amp;folder=$fpathname'>$fname</a>";
		if ("$current_folder"=="$fpathname") { echo "</em>"; }
        }
        echo "</p>\n\n";
}	
?>
